"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
analyis.proto
Contains RPC definitions for analysis
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import kerfed.protos.common.v1.fab_pb2
import kerfed.protos.common.v1.fileblob_pb2
import kerfed.protos.common.v1.mill_pb2
import kerfed.protos.common.v1.scene_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class AnalyzeSettings(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METHOD_ID_FIELD_NUMBER: builtins.int
    RENDER_PREVIEW_FIELD_NUMBER: builtins.int
    MILL_FIELD_NUMBER: builtins.int
    TITLE_BLOCK_FIELD_NUMBER: builtins.int
    UNITS_FIELD_NUMBER: builtins.int
    @property
    def method_id(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Specify which methods you want the pipeline to analyze.
        If unspecified will run and return all methods.
        Valid options include:
        `mill`, `flat`, `bent`, `roll`, `add`, `cots`.
        """
    render_preview: builtins.bool
    """Should the pipeline render raster previews?"""
    @property
    def mill(self) -> kerfed.protos.common.v1.mill_pb2.MillMachine:
        """Which milling machine should this analysis be done for?"""
    @property
    def title_block(self) -> kerfed.protos.common.v1.fab_pb2.TitleBlock:
        """Return drawings with a specific logo."""
    units: builtins.str
    """If the raw file is in a format that does not include unit
    information (i.e. SVG, DXF, STL, OBJ) specify the file's units
    through this request. If not passed the pipeline will "guess"
    which may or may not be correct.
    """
    def __init__(
        self,
        *,
        method_id: collections.abc.Iterable[builtins.str] | None = ...,
        render_preview: builtins.bool = ...,
        mill: kerfed.protos.common.v1.mill_pb2.MillMachine | None = ...,
        title_block: kerfed.protos.common.v1.fab_pb2.TitleBlock | None = ...,
        units: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mill", b"mill", "title_block", b"title_block"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["method_id", b"method_id", "mill", b"mill", "render_preview", b"render_preview", "title_block", b"title_block", "units", b"units"]) -> None: ...

global___AnalyzeSettings = AnalyzeSettings

@typing_extensions.final
class AnalyzeRequest(google.protobuf.message.Message):
    """Request a CAD file to be fully analyzed by the geometry pipeline."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SOURCE_FIELD_NUMBER: builtins.int
    SETTINGS_FIELD_NUMBER: builtins.int
    @property
    def source(self) -> kerfed.protos.common.v1.fileblob_pb2.FileBlob:
        """Raw CAD geometry to be analyzed in a supported format."""
    @property
    def settings(self) -> global___AnalyzeSettings:
        """Detailed settings to use for the analysis."""
    def __init__(
        self,
        *,
        source: kerfed.protos.common.v1.fileblob_pb2.FileBlob | None = ...,
        settings: global___AnalyzeSettings | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["settings", b"settings", "source", b"source"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["settings", b"settings", "source", b"source"]) -> None: ...

global___AnalyzeRequest = AnalyzeRequest

@typing_extensions.final
class AnalyzeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FABS_FIELD_NUMBER: builtins.int
    SCENE_FIELD_NUMBER: builtins.int
    @property
    def fabs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.fab_pb2.PartFabrication]:
        """The fabrication results."""
    @property
    def scene(self) -> kerfed.protos.common.v1.scene_pb2.Scene:
        """the loaded file in a neutral format"""
    def __init__(
        self,
        *,
        fabs: collections.abc.Iterable[kerfed.protos.common.v1.fab_pb2.PartFabrication] | None = ...,
        scene: kerfed.protos.common.v1.scene_pb2.Scene | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["scene", b"scene"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["fabs", b"fabs", "scene", b"scene"]) -> None: ...

global___AnalyzeResponse = AnalyzeResponse
